;
; Startup code for ՂՂ
;
;	by A.Watanabe
;
;----------------------------------------
;Based on:
;
; Startup code for cc65 (NES version)
;
; by Groepaz/Hitmen <groepaz@gmx.net>
; based on code by Ullrich von Bassewitz <uz@cc65.org>
;

	.export		_exit
	.export		__STARTUP__ : absolute = 1      ; Mark as startup
	.import		initlib, donelib, callmain
	.import		push0, _main, zerobss, copydata
	.import		ppubuf_flush

	.import		_nmi_main
	.import		_irq_main

	; Linker generated symbols
	.import		__RAM_START__, __RAM_SIZE__
	.import		__SRAM_START__, __SRAM_SIZE__
	.import		__ROM0_START__, __ROM0_SIZE__
	.import		__STARTUP_LOAD__,__STARTUP_RUN__, __STARTUP_SIZE__
	.import		__CODE_LOAD__,__CODE_RUN__, __CODE_SIZE__
	.import		__RODATA_LOAD__,__RODATA_RUN__, __RODATA_SIZE__

	.include	"zeropage.inc"
	.include	"nes.inc"

	.include	"..\..\include\nsd.inc"

; ------------------------------------------------------------------------
; 16 bytes INES header

.segment        "HEADER"

;    +--------+------+------------------------------------------+
;    | Offset | Size | Content(s)                               |
;    +--------+------+------------------------------------------+
;    |   0    |  3   | 'NES'                                    |
;    |   3    |  1   | $1A                                      |
;    |   4    |  1   | 16K PRG-ROM page count                   |
;    |   5    |  1   | 8K CHR-ROM page count                    |
;    |   6    |  1   | ROM Control Byte #1                      |
;    |        |      |   %####vTsM                              |
;    |        |      |    |  ||||+- 0=Horizontal mirroring      |
;    |        |      |    |  ||||   1=Vertical mirroring        |
;    |        |      |    |  |||+-- 1=SRAM enabled              |
;    |        |      |    |  ||+--- 1=512-byte trainer present  |
;    |        |      |    |  |+---- 1=Four-screen mirroring     |
;    |        |      |    |  |                                  |
;    |        |      |    +--+----- Mapper # (lower 4-bits)     |
;    |   7    |  1   | ROM Control Byte #2                      |
;    |        |      |   %####0000                              |
;    |        |      |    |  |                                  |
;    |        |      |    +--+----- Mapper # (upper 4-bits)     |
;    |  8-15  |  8   | $00                                      |
;    | 16-..  |      | Actual 16K PRG-ROM pages (in linear      |
;    |  ...   |      | order). If a trainer exists, it precedes |
;    |  ...   |      | the first PRG-ROM page.                  |
;    | ..-EOF |      | CHR-ROM pages (in ascending order).      |
;    +--------+------+------------------------------------------+

        .byte   $4e,$45,$53,$1a	; "NES"^Z
	.byte   2	        ; ines prg  - Specifies the number of 16k prg banks.
	.byte   1               ; ines chr  - Specifies the number of 8k chr banks.
	.byte   %00000011       ; ines mir  - Specifies VRAM mirroring of the banks.
	.byte   %00000000       ; ines map  - Specifies the NES mapper used.
	.byte   0,0,0,0,0,0,0,0	; 8 zeroes


; ------------------------------------------------------------------------
; Place the startup code in a special segment.

.segment	"STARTUP"

start:

; setup the CPU and System and Sound Driver nsd.lib

	sei
	cld

	lda	#0
	ldx	#0

@L0:
	sta	$0000,x	;Stack̓NAȂB
	sta	$0200,x
	sta	$0300,x
	sta	$0400,x
	sta	$0500,x
	sta	$0600,x
	sta	$0700,x
	inx
	bne	@L0

	ldx	#0
	stx	VBLANK_FLAG

	stx	ringread
	stx	ringwrite
	stx	ringcount

	txs

	lda	#$20
@l:	sta	ringbuff,x
	sta	ringbuff+$0100,x
	sta	ringbuff+$0200,x
	inx
	bne	@l

; Clear the BSS data

	jsr	zerobss

; initialize data

	jsr	copydata

; setup the stack

	lda	#<(__SRAM_START__ + __SRAM_SIZE__)
	sta	sp
	lda	#>(__SRAM_START__ + __SRAM_SIZE__)
	sta	sp+1		; Set argument stack ptr

; Call initialize sound driver

	jsr	_nsd_init

; Call module constructors

	jsr	initlib

; Push arguments and call main()

	jsr	callmain

; Call module destructors. This is also the _exit entry.

_exit:	jsr	donelib		; Run module destructors

; Reset the NES

	jmp start

; ------------------------------------------------------------------------
; hardware vectors
; ------------------------------------------------------------------------

.segment "VECTORS"

	.word	_nmi_main	; $fffa vblank nmi
	.word	start		; $fffc reset
	.word	_irq_main	; $fffe irq / brk

; ------------------------------------------------------------------------
; character data
; ------------------------------------------------------------------------

.segment "CHARS"

;	.include	"neschar.inc"

	.incbin		"gekioko.chr"


